"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
module.exports = void 0;
var Vue = _interopRequireWildcard(require("vue"));
var _prismjs = _interopRequireDefault(require("prismjs"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var _default = Vue.defineComponent({
  props: {
    code: {
      type: String
    },
    inline: {
      type: Boolean,
      default: false
    },
    language: {
      type: String,
      default: "markup"
    }
  },
  setup(props, {
    slots,
    attrs
  }) {
    const {
      h
    } = Vue;
    const slotsData = slots && slots.default && slots.default() || [];
    const code = props.code || (slotsData.length > 0 ? slotsData[0].children : "");
    const {
      inline,
      language
    } = props;
    const prismLanguage = _prismjs.default.languages[language];
    const className = `language-${language}`;
    if (inline) {
      return () =>
      //@ts-ignore
      h("code", {
        ...attrs,
        class: [attrs.class, className],
        innerHTML: _prismjs.default.highlight(code, prismLanguage)
      });
    }
    const d = _prismjs.default.highlight(code, prismLanguage);
    return () => h("pre", {
      ...attrs,
      class: [attrs.class]
    }, [h("code", {
      class: className,
      innerHTML: d
    })]);
  }
});
module.exports = _default;